#ifndef SPI_MANAGER_H__
#define SPI_MANAGER_H__
/*-------------------------------------------------------------------------*/
/*
		Susie Plug-in ǗNX

	last update: 2006/12/14
*/
/*-------------------------------------------------------------------------*/
/*
	t@C̎ނɉāAΉvOC𐶐

	܂Ãt@C^CvɑΉĂĂA
	vOC͈Ȃ̂ŁAŊǗ
*/

// IvV
#define	SPI_00AM		// A[JCupvOĈƂA`
//#define	SPI_USE_NEW		// vOCnewŐB̃t@CɑΉꍇA`
//#define	GET_PICTURE_INFO_READ_ALL	// GetPictureInfoŁASf[^ɓǂݍ
//#define	SPI_GET_PREVIEW	// GetPreview()ȂA`
//#define	SUSIE		// Susie ΍ŁA32bit -> 24bit

#include "spimisc.h"	// 낢
//#include "SpiConfig.h"	// ݒ_CAOisvȂADEFt@CConfigurationDlgIj

#include "ax_ald.h"
#include "ax_alk.h"

class SpiManager
{
protected:
	SpiBase* m_pSpi;
	SPI_INIT(SpiALD);
	SPI_INIT(SpiALK);

public:
	static LPCSTR m_pluginInfo[];

	// RXgN^/fXgN^
	SpiManager() : m_pSpi(NULL) {}

	~SpiManager()
	{
#ifdef	SPI_USE_NEW
		delete m_pSpi;
#endif
	}

	// ΉvOC̎擾
	SpiBase* QuerySpi(LPSTR fileName, BYTE* data)
	{
		IsSupported(fileName, data, this);
		return m_pSpi;
	}

	// Outor IsSupported
	static int IsSupported(LPSTR fileName, BYTE* data, SpiManager* pManager = NULL)
	{
		int result	= 1;
		LPCSTR extension	= (fileName == NULL) ? "" : Path::FindExtension(fileName);

		if (SpiALD::IsSupported(data, extension))
			SPI_ENTRY(SpiALD)
		else if (SpiALK::IsSupported(data, extension))
			SPI_ENTRY(SpiALK)
		else result	= 0;

		return result;
	}
};

#ifdef _MSC_VER
	_declspec(selectany)
#endif
// vOC
/*
	0 : vOC^Cv
	1 : o[W
	2Ԗڈȍ~́AΉt@C^Cv
	gqƐ݂ɕԂ悤ɂ
*/
LPCSTR SpiManager::m_pluginInfo[]	= {
#ifdef	SPI_00AM
			/* 0    */  "00AM",	// vOC^Cv
#else
			/* 0    */  "00IN",	// vOC^Cv
#endif
			/* 1    */  "Alice Soft ALD/ALK extract library ver.0.04 "
						"(C)2006-2010 Kouji",
			/* 2n+2 */  "*.ALD;*.ALK",
			/* 2n+3 */  "ALD/ALK file"
		};


#endif	// SPI_MANAGER_H__
