#ifndef	SPI_BASE_H__
#define	SPI_BASE_H__
//-----------------------------------------------------------------------------------------------------------
/* 

	SPIx[XNX		-ftHg̎iSāASPI_NO_FUNCTIONԂj

	last update: 2005/09/01

*/
//-----------------------------------------------------------------------------------------------------------
#include "spi_api.h"

class SpiBase
{
public:

//	SpiBase(){}
//	virtual ~SpiBase(){}

// operator		-CRTgpȂ悤
	static void* operator new(size_t nSize)
	{
		return HeapAlloc(GetProcessHeap(), 0, nSize);
	}

	static void operator delete(void *lpMem)
	{
		HeapFree(GetProcessHeap(), 0, lpMem);
	}

// SPI 00IN
	virtual int GetPictureInfo(BYTE* buf, DWORD len, PictureInfo *lpInfo)
	{
		return SPI_NO_FUNCTION;
	}

	virtual int GetPicture(BYTE* buf, DWORD len, HANDLE *pHBInfo, HANDLE *pHBm,
					SPI_CALLBACK lpPrgressCallback, long lData)
	{
		return SPI_NO_FUNCTION;
	}

	virtual int GetPreview(BYTE* buf, DWORD len, HANDLE *pHBInfo, HANDLE *pHBm,
					SPI_CALLBACK lpPrgressCallback, long lData)
	{
		return SPI_NO_FUNCTION;
	}

//SPI 00AM
	/*
		ȗ̂߁At@C͂ƃ͂̊֐𕪂
	*/
	// t@C
	virtual int GetArchiveInfo(LPSTR src, DWORD offset, HLOCAL *lphInf)
	{
		return SPI_NO_FUNCTION;
	}

	virtual int GetFileInfo(LPSTR src, DWORD offset, LPSTR filename,
					bool bCompareNoCase, fileInfo *lpInfo)
	{
		return SPI_NO_FUNCTION;
	}

	virtual int GetFile(LPSTR src, DWORD offset, LPSTR dest, bool bDestMemory,
					SPI_CALLBACK prgressCallback, long lData)
	{
		return SPI_NO_FUNCTION;
	}

	//
	virtual int GetArchiveInfoMem(LPSTR buf, DWORD len, HLOCAL *lphInf)
	{
		return SPI_NO_FUNCTION;
	}

	virtual int GetFileInfoMem(LPSTR buf, DWORD len, LPSTR filename,
					bool bCompareNoCase, fileInfo *lpInfo)
	{
		return SPI_NO_FUNCTION;
	}

	virtual int GetFileMem(LPSTR buf, DWORD len, LPSTR dest, bool bDestMemory,
					SPI_CALLBACK prgressCallback, long lData)
	{
		return SPI_NO_FUNCTION;
	}
};


/* ----------------------------------------------------------------------------------------------------------- */
/* SPI Map Macro */
#ifdef	SPI_USE_NEW

// vOCGg
#define SPI_INIT(Spi)	

// vOCGg
#define SPI_ENTRY(Spi)	\
{	\
	if (pManager != NULL)	\
		pManager->m_pSpi	= new Spi;	\
}

#else	// SPI_USE_NEW

// vOCGg
#define SPI_INIT(Spi)	Spi m_##Spi;

// vOCGg
#define SPI_ENTRY(Spi)	\
{	\
	if (pManager != NULL)	\
		pManager->m_pSpi	= &pManager->m_##Spi;	\
}

#endif	// SPI_USE_NEW

#endif	// SPI_BASE_H__